#ifndef  __UTILS_GRAPHICS_H__
#define __UTILS_GRAPHICS_H__

#define DEG_TO_RAD(degrees) (degrees) * M_PI / 180

void dump_matrix4x4(float *matrix);
void dump_vector4(float *vector);
void mult_matrices(float *output_matrix, float *matrix1, float *matrix2, int matrix_size);
void transform_vector(float *output_vector, float *input_matrix, float *input_vector, int vec_matrix_size);

void get_translation_matrix4x4(float *output_matrix, float x, float y, float z);
void get_rotation_x_matrix4x4(float *output_matrix, float angle);
void get_rotation_y_matrix4x4(float *output_matrix, float angle);
void get_rotation_z_matrix4x4(float *output_matrix, float angle);

void get_identity_matrix(float *output_matrix);
void get_perspective_matrix(float *output_matrix, float fovy, float aspect, float near, float far);
void transpose_matrix(float *output_matrix, float *input_matrix, int matrix_size);

#endif
